<script setup lang="ts">
    import { computed, ref, watch } from 'vue'
    import 'leaflet/dist/leaflet.css'
    import L from 'leaflet'
    import 'leaflet-gesture-handling/dist/leaflet-gesture-handling.css'
    import 'leaflet.markercluster/dist/MarkerCluster.css'
    import 'leaflet.markercluster/dist/MarkerCluster.Default.css'
    import 'leaflet.markercluster'
    import { GeolocalisableItem } from '../entities/GeolocalisableItem'
    import { ListableItem } from '../entities/ListableItem'
    import { useLeafletMap } from '@/shared/map/composables/useLeafletMap'
    import { isUndefined, isDefined } from '@/shared/helpers/types'
    import { isDesktop } from '@/shared/helpers/device'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { useApproximateAddress } from '@/shared/geocoding/composables/useApproximateAddress'
    import { LatLngLiteral } from 'leaflet'
    import { ComputedRef } from 'vue'

    interface Props {
        id?: string
        items?: Array<GeolocalisableItem & ListableItem>
        preventDrag?: boolean
        selectedItemId?: string
    }
    let laVueADejaEteRecadreeAvecLaPositionUtilisateur = false

    const msal = useMsal()
    const props = withDefaults(defineProps<Props>(), {
        items: undefined,
        id: () => 'mapViewerContainer-' + self.crypto.randomUUID(),
        preventDrag: false,
        selectedItemId: undefined,
    })

    const emit = defineEmits<{
        (e: 'clickItem', item: ListableItem & GeolocalisableItem): void
        (e: 'doubleClickItem', item: ListableItem & GeolocalisableItem): void
    }>()

    const displayedAddressCoordinates: ComputedRef<LatLngLiteral | undefined> =
        computed(() => {
            if (isUndefined(props.items)) {
                return undefined
            }
            if (props.items.length !== 1) return undefined
            return props.items[0].getCoordinates()
        })

    const { approximateAddress } = useApproximateAddress(
        displayedAddressCoordinates,
        msal
    )

    const { map, currentPositionMarker, changeMapLayer } = useLeafletMap({
        containerId: props.id,
        viewOptions: {},
        preventDrag: props.preventDrag,
    })

    const objectsMarkerClusterGroup = L.markerClusterGroup({})
    const markerList = ref<Record<string, L.Marker>>({})

    watch([map, () => props.items], () => {
        if (isUndefined(map.value)) {
            return
        }
        if (!map.value.hasLayer(objectsMarkerClusterGroup)) {
            objectsMarkerClusterGroup.addTo(map.value)
        }
        updateObjectsMarkers()
        if (isDefined(props.selectedItemId)) {
            const selectedMarker = markerList.value[props.selectedItemId]
            if (isDefined(selectedMarker)) {
                objectsMarkerClusterGroup.zoomToShowLayer(selectedMarker)
            }
        } else {
            fitBoundsIfPossible()
            map.value.setZoom(Math.min(map.value.getZoom(), 18))
        }
    })

    watch(currentPositionMarker, () => {
        // ici l'idée est de cadrer avec la position de l'utilisateur si il utilise un mobile
        if (isUndefined(currentPositionMarker.value)) {
            return
        }
        if (isUndefined(map.value)) {
            return
        }
        if (isDesktop()) {
            return
        }
        // Quand un élément est selectionné, on garde le focus dessus
        if (isDefined(props.selectedItemId)) {
            return
        }
        if (laVueADejaEteRecadreeAvecLaPositionUtilisateur) {
            return
        }

        fitBoundsIfPossible([currentPositionMarker.value])
        map.value.setZoom(Math.min(map.value.getZoom(), 18))

        laVueADejaEteRecadreeAvecLaPositionUtilisateur = true
    })

    watch(
        [() => props.selectedItemId],
        (newSelectedItemId, oldSelectedItemId) => {
            if (isUndefined(map.value)) {
                return
            }
            if (isDefined(oldSelectedItemId[0])) {
                const oldSelectedMarker = markerList.value[oldSelectedItemId[0]]
                oldSelectedMarker?.setIcon(defaultItemMarker)
            }
            if (isUndefined(newSelectedItemId[0])) {
                return
            }

            const newSelectedMarker = markerList.value[newSelectedItemId[0]]

            if (newSelectedMarker) {
                newSelectedMarker.setIcon(selectedItemMarker)
                objectsMarkerClusterGroup.zoomToShowLayer(newSelectedMarker)
            }
        }
    )

    const defaultItemMarker = L.divIcon({
        className:
            'mdi mdi-map-marker s-leaflet-marker-default d-flex justify-center align-center',
        iconSize: [32, 41],
        iconAnchor: [16, 41],
    })
    const selectedItemMarker = L.divIcon({
        className:
            'mdi mdi-map-marker s-leaflet-marker-select d-flex justify-center align-center',
        iconSize: [51, 68],
        iconAnchor: [25.5, 68],
    })

    function updateObjectsMarkers() {
        objectsMarkerClusterGroup.clearLayers()
        markerList.value = {}
        if (isUndefined(props.items)) return
        if (props.items.length === 0) return
        props.items.forEach((item) => {
            const itemCoordinates = item.getCoordinates()
            if (itemCoordinates) {
                const marker = L.marker(itemCoordinates, {
                    alt: `map-marker-object-${item.getItemId()}`,
                    icon: defaultItemMarker,
                })
                if (item.getItemId() === props.selectedItemId) {
                    marker.setIcon(selectedItemMarker)
                }

                marker.on('click', () => {
                    emit('clickItem', item)
                })
                marker.on('dblclick', () => {
                    emit('doubleClickItem', item)
                })

                objectsMarkerClusterGroup.addLayer(marker)
                markerList.value[item.getItemId()] = marker
            }
        })
        objectsMarkerClusterGroup.refreshClusters()
    }

    function fitBoundsIfPossible(additionalObjects: L.Layer[] = []) {
        if (isUndefined(map.value)) {
            return
        }
        const objectsAndAddintionnalObjectsMarkerGroup = L.featureGroup([
            objectsMarkerClusterGroup,
            ...additionalObjects,
        ])

        if (objectsAndAddintionnalObjectsMarkerGroup.getBounds().isValid()) {
            map.value.fitBounds(
                objectsAndAddintionnalObjectsMarkerGroup.getBounds(),
                {
                    padding: [40, 40],
                }
            )
        }
    }
</script>

<template>
    <div>
        <div
            :id="id"
            data-cy="component-item-map-viewer"
            class="position-absolute top-0 right-0 bottom-0 left-0"
        >
            <div
                v-if="isDefined(approximateAddress.data)"
                class="map-address-box"
            >
                <v-icon icon="mdi-map-outline" /> {{ approximateAddress.data }}
            </div>
        </div>
        <div
            class="position-absolute top-0 left-0 right-0 d-flex"
            style="height: 50px; z-index: 1000; pointer-events: none"
        >
            <div class="flex-grow-1 pa-2">
                <div style="pointer-events: initial">
                    <slot name="topOverlay"></slot>
                </div>
            </div>
            <div
                class="flex-grow-0 flex-shrink-0"
                style="pointer-events: initial"
            >
                <button
                    class="silab-leaflet-control ma-2"
                    style="pointer-events: initial; font-size: 12px"
                    @click="changeMapLayer()"
                >
                    <v-icon icon="mdi-layers-outline"></v-icon>
                </button>
            </div>
        </div>
        <div
            style="
                pointer-events: none;
                position: absolute;
                left: 0;
                top: 50px;
                right: 0;
                bottom: 0;
                z-index: 1000;
            "
        >
            <div
                class="h-100"
                style="pointer-events: initial; width: fit-content"
            >
                <slot name="mainOverlay"></slot>
            </div>
        </div>
    </div>
</template>

<style scoped lang="scss">
    @use '../../map/styles/style.scss';
</style>
<style lang="scss">
    .s-leaflet-marker-default {
        font-size: 50px !important;
        color: #0873bb;
    }

    .s-leaflet-marker-select {
        font-size: 80px !important;
        color: #fbae3a;
    }
</style>
